#
# spec file for package websphere-as_ce (Version 2.1.1.2)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl ant ant-trax attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs expat-32bit file filesystem fillup findutils flex fontconfig-32bit freetype2-32bit gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-32bit glibc-devel glibc-locale gpm grep groff gzip info insserv jaf java-1_4_2-sun java-1_4_2-sun-devel jpackage-utils klogd less libacl libattr libcom_err libgcc libgssapi libmudflap libnscd libstdc++ libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt post-build-checks procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip update-alternatives util-linux vim xalan-j2 xerces-j2 xorg-x11-libs-32bit zlib zlib-32bit zlib-devel


Name:           websphere-as_ce
%define major_version   2.1
%define base_name       websphere-as_ce
%define short_name      websphere
%define section         free
%define source_top      %{name}-%{cvs_version}
%define alternativesdir var
%define commons_dir     %{_builddir}/commons_dir
%define commons_file_list %{_builddir}/files
%define full_name       %{name}-%{major_version}
%define geronimo_home   %{_datadir}/%{full_name}
%define tmp_dir         %{_builddir}/tmp_dir
%define rw_dirs         %{_localstatedir}/cache/%{full_name}/
%define deploy_dir      %{rw_dirs}/deploy
%define repository_dir  %{rw_dirs}/repository
%define base_dir        /srv/%{full_name}
%define geronimo_temp      %{_localstatedir}/cache/%{full_name}/tmp
%define geronimo_user_home /var/lib/geronimo
#<<<
#>>> packages properties
#>>> main
BuildRequires:  ant-trax diffutils jaf java-1_4_2-sun-devel update-alternatives
Version:        2.1.1.2
Release:        0.3
Summary:        IBM WebSphere Application Server Community Edition
Url:            http://www-306.ibm.com/software/webservers/appserv/community/
Source0:        %{base_name}-%{version}.tar.bz2
NoSource:       0
Source2:        rcgeronimo
Source3:        sysconfig.%{full_name}
Source4:        README.SuSE
Source5:        websphere.conf
Patch:          %{name}-setenv.patch
License:        Any commercial
Group:          Productivity/Networking/Web/Servers
BuildArch:      noarch
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Provides:       %{name} = %{version}-%{release}
PreReq:         %fillup_prereq
Requires:       jre >= 1.5.0
PreReq:         /usr/sbin/useradd, /usr/sbin/groupadd, sed, /usr/bin/install

%description
IBM WebSphere Application Server Community Edition is a lightweight
J2EE application server available free of charge. Built on Apache
Geronimo technology, it harnesses the latest innovations from the
open-source community to deliver an integrated, readily accessible and
flexible foundation for developing and deploying Java applications.
Through the use of best-of-breed, open-source applications such as
Eclipse, Apache Tomcat, and IBM Cloudscape database based on Apache
Derby, WebSphere Application Server Community Edition delivers a clear
path to the advanced capabilities of the WebSphere middleware
portfolio. You can take advantage of technical support through an
annual subscription.

Please take a moment to review the license before installing.


_&li_formnum=L-TGEE-7F57GL&title=WebSphere+Application+Server+Community
+Edition+2.1&l_



Authors:
--------
    IBM

%build
# nothing to do here

%prep
%setup -q -c %{name}-%{major_version}
%patch
# rm bin/setenv.sh.orig
#>>> delete uninstall dir:
rm -rf _uninst
# adjust java default path
#sed -i -e 's|.*WASCE_JAVA_HOME=.*|WASCE_JAVA_HOME="/etc/alternatives/jre"|g' bin/setenv.sh
#<<< extract end
mkdir -p %{commons_dir}
# removing files which are probably unimportant
rm -rf META-INF
# bnc#427726 comment#15
# rm -rf etc/rc.d
# common dir
find . -iname *config.xml.bak -or -iname *.orig | xargs rm
find . -iname *sh | xargs chmod a+x
mv * %{commons_dir}/
cp %{SOURCE2} %{SOURCE5} .
sed -i -e 's|@@VERSIONED_NAME@@|%{base_name}-%{major_version}|g' \
       -e 's|@@GERONIMO_HOME@@|%{geronimo_home}|g' \
       -e 's|@@DEPLOY_DIR@@|%{deploy_dir}|g' websphere.conf
sed -i -e 's|@@GERONIMO_REPOSITORY@@|%{repository_dir}|g' \
       -e 's|@@VERSIONED_NAME@@|%{base_name}-%{major_version}|g' \
       -e 's|@@NAME@@|%{name}|g' \
       -e 's|@@GERONIMO_VAR_TEMP@@|%{geronimo_temp}|g' rcgeronimo

%install
export NO_BRP_CHECK_BYTECODE_VERSION="true"
#>>> sysv init and logging
install -d -m 755 $RPM_BUILD_ROOT/{%{_sbindir},%{_sysconfdir}/init.d}
install rcgeronimo $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{short_name}
ln -sf %{_sysconfdir}/init.d/%{short_name} $RPM_BUILD_ROOT/%{_sbindir}/rc%{short_name}
install -m 755 -d $RPM_BUILD_ROOT%{_var}/adm/fillup-templates/
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_var}/adm/fillup-templates/
#<<<
# copy files
install -m 755 -d $RPM_BUILD_ROOT/%{geronimo_home}
cp -a %{commons_dir}/* $RPM_BUILD_ROOT/%{geronimo_home}
# These files can be removed from our distro, see comment #33 in (bnc#341419)
rm $RPM_BUILD_ROOT/%{geronimo_home}/bin/{preUninstall.sh,postInstall.sh,genVersionReport.sh,versionInfo.sh}
# move var/log/* to /var/log/websphere-as_ce-2.0 
install -d -m 0755 $RPM_BUILD_ROOT/%{_localstatedir}/log/%{full_name}
mv $RPM_BUILD_ROOT%{geronimo_home}/var/log/* $RPM_BUILD_ROOT/%{_localstatedir}/log/%{full_name}
rm -rf $RPM_BUILD_ROOT%{geronimo_home}/var/log/
ln -sf %{_localstatedir}/log/%{full_name} $RPM_BUILD_ROOT%{geronimo_home}/var/log
# move var/config/* to /etc/websphere-as_ce-2.0
install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/%{full_name}
install -m 644 websphere.conf $RPM_BUILD_ROOT/%{_sysconfdir}/%{full_name}
mv $RPM_BUILD_ROOT%{geronimo_home}/var/config/* $RPM_BUILD_ROOT/%{_sysconfdir}/%{full_name}
rm -rf $RPM_BUILD_ROOT%{geronimo_home}/var/config
ln -sf %{_sysconfdir}/%{full_name} $RPM_BUILD_ROOT%{geronimo_home}/var/config
# move var/security into /etc/websphere-as_ce-2.0
mv $RPM_BUILD_ROOT%{geronimo_home}/var/security $RPM_BUILD_ROOT/%{_sysconfdir}/%{full_name}
ln -sf %{_sysconfdir}/%{full_name}/security $RPM_BUILD_ROOT%{geronimo_home}/var/security
# move var/temp to /var/tmp/websphere-as_ce-2.0
install -d -m 755 $RPM_BUILD_ROOT/%{geronimo_temp}
rm -rf $RPM_BUILD_ROOT%{geronimo_home}/%{_localstatedir}/temp
ln -sf %{geronimo_temp}  $RPM_BUILD_ROOT%{geronimo_home}/var/temp
# finally move whole var into /srv/websphere-as_ce-2.0
install -d -m 0755 $RPM_BUILD_ROOT/%{base_dir}/var
mv $RPM_BUILD_ROOT%{geronimo_home}/var/* $RPM_BUILD_ROOT/%{base_dir}/var
rm -rf $RPM_BUILD_ROOT%{geronimo_home}/var
ln -sf %{base_dir}/var $RPM_BUILD_ROOT%{geronimo_home}/var
# etc dir
mv $RPM_BUILD_ROOT/%{geronimo_home}/etc/* $RPM_BUILD_ROOT/%{_sysconfdir}/%{full_name}
# bnc#427726 comment#13
rmdir $RPM_BUILD_ROOT/%{geronimo_home}/etc
ln -sf %{_sysconfdir}/%{full_name} $RPM_BUILD_ROOT/%{geronimo_home}/etc
# docdir
install -m 755 -d $RPM_BUILD_ROOT%{_docdir}/%{full_name}
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_docdir}/%{full_name}
mv $RPM_BUILD_ROOT/%{geronimo_home}/README.htm  $RPM_BUILD_ROOT%{_docdir}/%{full_name}
mv $RPM_BUILD_ROOT/%{geronimo_home}/license  $RPM_BUILD_ROOT%{_docdir}/%{full_name}
mv $RPM_BUILD_ROOT/%{geronimo_home}/CHANGES.txt $RPM_BUILD_ROOT%{_docdir}/%{full_name}
ln -sf %{_docdir}/%{full_name}/license $RPM_BUILD_ROOT/%{geronimo_home}/license
# deploy dir
install -m 755 -d $RPM_BUILD_ROOT/%{deploy_dir}
rm -rf $RPM_BUILD_ROOT/%{geronimo_home}/deploy
ln -sf %{deploy_dir} $RPM_BUILD_ROOT/%{geronimo_home}/deploy
# repository dir
install -m 755 -d $RPM_BUILD_ROOT/%{repository_dir}
mv $RPM_BUILD_ROOT/%{geronimo_home}/repository/* $RPM_BUILD_ROOT/%{repository_dir}
rm -rf $RPM_BUILD_ROOT/%{geronimo_home}/repository/
ln -sf %{repository_dir} $RPM_BUILD_ROOT/%{geronimo_home}/repository
# create a geronimo base
# install -d -m 755 $RPM_BUILD_ROOT/%{base_dir}
pushd $RPM_BUILD_ROOT/%{base_dir}
  for file in `ls $RPM_BUILD_ROOT/%{geronimo_home}/`
  do
    ln -sf %{geronimo_home}/$file || :
  done
popd 
# create a home dir for geronimo user
install -d -m 0755 $RPM_BUILD_ROOT/%{geronimo_user_home}
#<<< install

%clean
rm -rf $RPM_BUILD_ROOT
#>>> pre & post scripts

%pre
# Add the "geronimo" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -r geronimo 2> /dev/null || :
%{_sbindir}/useradd -c "Geronimo" -g geronimo \
    -s /bin/sh -r -d %{geronimo_user_home} geronimo 2> /dev/null || \
    %{_sbindir}/usermod -d %{geronimo_user_home} geronimo

%post
# id geronimo && chown -R geronimo %{_localstatedir}/log/%{name}-%{major_version}
# id geronimo && chown -R geronimo /%{base_dir}
# %{fillup_only}
config_file=/etc/sysconfig/%{full_name}
fillup_file=/var/adm/fillup-templates/sysconfig.%{full_name}
touch $config_file
fillup --maintain $config_file $fillup_file
#>>> files
#>>> commons

%postun
%restart_on_update %{short_name}
%insserv_cleanup

%preun
%stop_on_removal %{short_name}

%files 
%defattr(-,geronimo,geronimo,-)
%dir %{_sysconfdir}/%{full_name}
%dir %{_sysconfdir}/%{full_name}/security
%dir %{_sysconfdir}/%{full_name}/META-INF
%dir %{_sysconfdir}/%{full_name}/META-INF/plexus
%config %{_sysconfdir}/%{full_name}/*.xml
%config %{_sysconfdir}/%{full_name}/*.properties
%config %{_sysconfdir}/%{full_name}/websphere.conf
%config %{_sysconfdir}/%{full_name}/security/*.properties
%config %{_sysconfdir}/%{full_name}/META-INF/plexus/plexus.xml
%config %{_sysconfdir}/%{full_name}/gsh-classworlds.conf
%config %{_sysconfdir}/%{full_name}/rc.d
%{_sysconfdir}/%{full_name}/security/keystores
%{_sysconfdir}/%{full_name}/README.txt
%{_localstatedir}/log/%{full_name}
%{base_dir}/var
%dir %{rw_dirs}
%{rw_dirs}/repository
%dir %{geronimo_user_home}
%defattr(-,root,root,-)
%doc %{_docdir}/%{full_name}
%dir %{geronimo_home}
%{geronimo_home}/_version.properties
%{geronimo_home}/bin
%{geronimo_home}/cluster-repository
%{geronimo_home}/etc
%{geronimo_home}/deploy
%{geronimo_home}/graphics
%{geronimo_home}/lib
%{geronimo_home}/license
%{geronimo_home}/master-repository
%{geronimo_home}/repository
%{geronimo_home}/schema
%{geronimo_home}/var
%{geronimo_home}/properties
%dir %{base_dir}
%{base_dir}/_version.properties
%{base_dir}/bin
%{base_dir}/cluster-repository
%{base_dir}/etc
%{base_dir}/deploy
%{base_dir}/graphics
%{base_dir}/lib
%{base_dir}/license
%{base_dir}/master-repository
%{base_dir}/repository
%{base_dir}/schema
%{base_dir}/properties
%{_var}/adm/fillup-templates/*
%{_sysconfdir}/init.d/%{short_name}
/usr/sbin/rc%{short_name}
%{rw_dirs}/deploy
%dir %{geronimo_temp}
#<<< main end
#>>> tomcat

%changelog
* Thu Jun 18 2009 - mvyskocil@suse.cz
- Update to 2.1.1.2 (bnc#507806)
  - Upgrade to Apache Geronimo Server 2.1.4
  - Upgrade to Apache OpenJPA 1.2.1
  - Upgrade to OpenEJB 3.0.1
  - Upgrade to MyFaces 1.2.6
  - Support for SR9 of IBM 1.5.0 SDK and SR4 of IBM 1.6.0 SDK, Java Technology
  Edition
- Fixed a geronimo user location to /var/lib/geronimo bnc#457154,comment#12
* Fri Nov 21 2008 - mvyskocil@suse.cz
- Fixes according IBM's test
  see comment#13 in bnc#427726:
  - changed Requires from java to jre to allow a third party rpm packages
  - fixed a WASCE_HOME value in setenv.sh
  - the /usr/share/websphere-as_ce-2.1/etc is a symlink to
  /etc/websphere-as_ce-2.1
  see comment#15 in bnc#427726
 - added a wasce_home/rc.d/start-server,default.groovy
 - fixed a README.SuSE
- Don't modify a %%{SOURCE2} and %%{SOURCE5} directly, copy them first to build
  directory. Also make a modification more readable (one expression per line)
- Fix a type ($local_fd) in rcgeronimo
- Test of pid file existence in rcgeronimo to avoid error messages if the
  server is not running during stop
- Added a postun and preun initscript handling
- Moved the temp dir to /var/cache/name/tmp to be consistent with FHS
* Fri Sep 19 2008 - anosek@suse.cz
- updated to version 2.1.0.1 (bnc#427726)
  This release is based on:
  -------------------------
  Apache Geronimo Server 2.1.1
  Apache OpenEJB 3.0
  Apache OpenJPA 1.0.2
  Apache ActiveMQ 4.1.2
  Apache ActiveIO 3.0.1
  Apache Geronimo Yoko 1.0
  Apache Pluto 1.1.6-G643117
  Apache Tomcat 6.0.16-G652117
  + lots of bugfixes
* Thu Mar 20 2008 - anosek@suse.cz
- moved /var/lib/websphere-as_ce-2.0 into /srv
* Wed Mar 19 2008 - anosek@suse.cz
- adjusted spec file according to comment #33 (bnc#341419)
- added patch (setenv.patch)
* Fri Jan 25 2008 - ro@suse.de
- added /var/cache/websphere-as_ce-2.0 to filelist
* Thu Jan 24 2008 - anosek@suse.cz
- added %%config directive for config files in /etc/websphere-as_ce
- chown geronimo.geronimo for /var/cache/websphere-as_ce-2.0/repository
* Wed Jan 23 2008 - anosek@suse.cz
- fixed VUL-0: the start script of geronimo changes permissions of /var/tmp/* [#353919]
  - removed dangerous 'chown -R -L geronimo:geronimo ...' lines from rcwebsphere
  - adjusted file permissions in spec appropriately
* Thu Dec 06 2007 - anosek@suse.cz
- moved some settings from sysconfig.websphere-as_ce into websphere.conf
- fixed wronly set JAVA_HOME variable
* Thu Nov 22 2007 - anosek@suse.cz
- updated to version 2.0.0.1
  Updated components:
  -------------------
  Apache Geronimo Server 2.0.2 (Rev586046)
  Apache OpenEJB 3.0-beta-1 (Rev579760)
  Apache OpenJPA 1.0.0 (Rev570500)
  + lots of patches added (see CHANGES.txt)
* Wed Nov 07 2007 - anosek@suse.cz
- updated to version 2.0.0.0, fate #302755
  This release is based on:
  -------------------------
  Apache Geronimo Server 2.0.1 (Rev566358)
  Apache Axis2 1.3-r562247 (Rev562247)
  Apache OpenEJB 3.0.0-r562820 (Rev562831)
  Apache OpenJPA 1.0.0-r561970 (Rev562584)
  Apache Yoko 1.0-incubating-r557035 (Rev556937)
  To determine what fixes and features were included in Apache Geronimo 2.0.1,
  use the following website and the Find Issues link to list which JIRA
  issues were incorporated since Apache Geronimo 1.1.1 -
  http://issues.apache.org/jira/browse/GERONIMO
  WASCE v2.0.0.0 unique changes:
  ------------------------------
    - Additional scripts added to bin directory for Derby and WASCE version info
    - Full support for the IBM 1.5.0 SDK, Java Technology Edition
    - Removed ApacheDS, CXF, Jetty, JLine and WADI modules from the delivered server runtime
    - Recognize the JVM from Azul Systems, Inc. and Apple Inc. as a Sun JVM
    - Replaced Sun RI version of JSTL 1.2 with an IBM rebuilt version of 1.2-1 that works with the IBM SDK
    - Replaced Apache Woodstox with IBM XLXP v1.1.2
    - Replaced XercesImpl 2.8.1 with the version from IBM XML4J v4.4.10
    - Replaced Xml-Resolver 1.1 with the version from IBM XML4J v4.3.11
    - Replaced Geronimo rebuilt Tomcat 6.0.13 with an IBM SDK rebuilt version of 6.0.13-1
    - Removed DoubleMetaphone.java implementation from commons-codec-1.3.jar
* Wed Apr 18 2007 - dbornkessel@suse.de
- changed version string (Bug #256263)
* Mon Mar 05 2007 - dbornkessel@suse.de
- fixed bugs #251193 and #251190 (missing java require + make repository dir writable)
* Wed Feb 28 2007 - dbornkessel@suse.de
- copied last adjustments from geronimo:
  - enabled passwordless shutdown (Bug #183703)
  - fixed Bug #246284
  - adjusted README files accordingly
  - fix 'status' query of the runtime script
* Tue Feb 13 2007 - dbornkessel@suse.de
- link to licenses in app dir (Bug #239972)
- added CHANGES.txt to doc dir
* Fri Jan 05 2007 - dbornkessel@suse.de
- do not alter the setenv.sh script
* Thu Jan 04 2007 - dbornkessel@suse.de
- removed ant dependency
